Name:           aubit4gl
Version:        20221019.r12787
Release:        1%{?dist}
Summary:        Informix-4GL compatible compiler

# The entire source code is GPLv2+ except
# tools/cgi_4gl which is MIT
# lib/bin/svn2cl.xsl which is BSD
# lib/libaubit4gl/curl.c which is BSD
# lib/extra_libs/mantisconnect/pregen which is GPL+
# tools/adbload2/adbload2_parse_pregen.tab.c which is GPLv3+
# tools/no_yacc/cygwin/compilers which is GPLv3+
# lib/libui/ui_json/libjson.c which is LGPLv2+
# lib/libui/ui_xml which is LGPLv2+
# incl/json.h which is MIT
# lib/libaubit4gl/json.c which is MIT
# lib/extra_libs/memcached/memcache.h which is MIT
# lib/libaubit4gl/mapm which is NTP
License:        GPLv2+ and GPLv3+ and GPL+ and LGPLv2+ and MIT and BSD
URL:            http://www.aubit.com
Provides:       libaubit4gl.so()(64bit)
Source0:        https://downloads.sourceforge.net/project/stansoft/src/aubit4gl-%{version}.tar.bz2
Source1:        https://downloads.sourceforge.net/project/stansoft/src/aubitmanpages.tar.bz2

BuildRequires:  gcc
BuildRequires:  ncurses-devel
BuildRequires:  postgresql-server
BuildRequires:  libpq-devel
BuildRequires:  bison flex procps-ng
 

%description
Aubit 4GL compiler is software that translates Informix 4GL programming
language into executable programs.


%package devel
Summary: Development files for %{name}
Requires: %{name}%{?_isa} = %{version}-%{release}
%description devel
%{summary}.


%prep
%setup


%build
./configure --disable-prefix-check \
            --prefix=%{buildroot}%{_libdir}/%{name}
# It does not compile with multiple threads
%make_build -j1


%install
rm -rf %{buildroot}%{_libdir}/%{name}
mkdir -p %{buildroot}%{_libdir}/%{name}
mkdir -p %{buildroot}/etc/ld.so.conf.d
mkdir -p %{buildroot}%{_includedir}/aubit4gl
mkdir -p %{buildroot}%{_mandir}/man1
tar xvf %{SOURCE1} -C %{buildroot}%{_mandir}/man1

%make_install aubitrc=new

# Remove files which will not be packaged, to cleanup licensing
rm %{buildroot}%{_libdir}/%{name}/bin/aace_4gl

# Move files that do not belong in the base package
mv %{buildroot}%{_libdir}/%{name}/incl/*.h %{buildroot}%{_includedir}/aubit4gl

# Move the Aubit4GL library into the system library directory
mv %{buildroot}%{_libdir}/%{name}/lib/libaubit4gl*.so %{buildroot}%{_libdir}

# Remove files which will not be packaged
rm -rf $(find %{buildroot}%{_libdir}/%{name} \
         ! -path '%{buildroot}%{_libdir}/%{name}/bin*' \
         ! -path '%{buildroot}%{_libdir}/%{name}/plugins-*' \
         ! -path '%{buildroot}%{_libdir}/%{name}/etc' \
         ! -path '%{buildroot}%{_libdir}/%{name}/etc/aubitrc' \
         ! -path '%{buildroot}%{_libdir}/%{name}/etc/convertsql*' \
         ! -path '%{buildroot}%{_libdir}/%{name}')

# Create file in /etc/ld.so.conf.d for the Aubit4GL shared object plugins
echo -e "%{_libdir}/%{name}/plugins-*" > %{buildroot}/etc/ld.so.conf.d/%{name}-%{_arch}.conf

# Create relative soft links to the binaries
mkdir -p %{buildroot}%{_bindir}
cd %{buildroot}%{_bindir}
ln -s ../..%{_libdir}/%{name}/bin/4glpc .
ln -s ../..%{_libdir}/%{name}/bin/4glc .
ln -s ../..%{_libdir}/%{name}/bin/fcompile .
ln -s ../..%{_libdir}/%{name}/bin/amkmessage .
cd %{buildroot}%{_libdir}/%{name}/plugins-*
# To avoid duplicate build-ids with libLEX_C and libLEX_CS, create a link
ln -sf libLEX_C.so libLEX_CS.so
# Put the Aubit4GL aubitrc config file into place
cp %{_builddir}/%{name}-%{version}/etc/aubitrc \
   %{buildroot}%{_libdir}/%{name}/etc

# Fixup paths in aubitrc
sed -i -e "s|%{buildroot}||g" \
       -e "s|%{_builddir}/%{name}-%{version}|%{_libdir}/%{name}|g" \
       -e "s|$HOME/.aubit4gl|%{_libdir}/%{name}/etc|g" \
       %{buildroot}%{_libdir}/%{name}/etc/aubitrc


cd %{buildroot}%{_libdir}/%{name}


%check
make test


%files
%license docs/COPYING 
%doc README.txt
%{_libdir}/%{name}
%{_libdir}/libaubit4gl*.so
/etc/ld.so.conf.d/%{name}-%{_arch}.conf
%{_bindir}/4glpc
%{_bindir}/4glc
%{_bindir}/fcompile
%{_bindir}/amkmessage
%{_mandir}/man1/*


%files devel
%{_includedir}/aubit4gl/


%changelog
* Mon Aug 15 2022 Chad Lemmen <rpm@stansoft.org> - 20220730.r12784-1
- initial Fedora RPM packaging

